module(..., package.seeall)

local m_apiUtils = require "api.utils"
local m_datasource

function GetName()
	return "BatchManagement"
end

function GetDatasource()
	return m_datasource
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetBatch(batchId, includeStatistics, keyspace)
	return m_apiUtils.GetBatchModel("Batches").GetBatch(batchId, includeStatistics, keyspace, m_datasource)
end

function GetAddressesStatus(batchId, keyspace, addresses)
	return m_apiUtils.GetBatchModel("Batches").GetAddressesStatus(batchId, keyspace, addresses)
end

function GetAddressStatus(batchId, address, keyspace)
	return m_apiUtils.GetBatchModel("Batches").GetAddressStatus(batchId, address, keyspace, m_datasource)
end
