module(..., package.seeall)

local m_apiUtils = require "api.utils"
local m_datasource

function GetName()
	return "Campaigns"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetCampaign(vcc, Id, keyspace, columns)
	return m_apiUtils.GetAdmModel("Campaigns").GetCampaign(vcc, Id, keyspace, columns)
end

function GetVccAccounts(vcc, keyspace)
	return m_apiUtils.GetAdmModel("Campaigns").GetVccAccounts(vcc, keyspace)
end

function GetCampaignAccounts(campaignAtVCC, keyspace, columns)
	return m_apiUtils.GetAdmModel("Campaigns").GetCampaignAccounts(campaignAtVCC, keyspace, columns)
end

function GetCampaignAccount(campaignAtVCC, accountId, keyspace, columns)
	return m_apiUtils.GetAdmModel("Campaigns").GetCampaignAccount(campaignAtVCC, accountId, keyspace, columns)
end
