local m_definitions = {
	basic = {
		isSimple = false,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Id",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the app Id.",
					html_malicious_code = "Possible malicious code in the app Id.",
				}
			},
			{
				field_id = "Description",
				validations = {
					html_malicious_code = "Possible malicious code in the app Description.",
				}
			},
			{
				field_id = "Url",
				validations = {
					html_malicious_code = "Possible malicious code in the app notifications Url.",
					url = "The app notifications url must be valid."
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}
