var icControl;

function ProcessResponse(response) {

	console.log("LOG:" + JSON.stringify(response));
	var messageId = response.messageId;
	switch (messageId) {

		//event
		case "Taken":
			document.forms.formLogin.elements.interaction2.value = response.data.id;
		case "Wrapup":
		case "Unanswered":
		case "AutomaticWrapupTimeout":
		case "Transfer":
		case "AutomaticInactivityTimeout":
			console.log("LOG EVENT:" + messageId + " RESULT:" + JSON.stringify(response.data));
			break;

		//user response
		case "response_user_getcompanyinformation":
		case "response_user_getcustominformation":
		case "response_user_getcompletename":
		case "response_user_getfirstname":
		case "response_user_getlastname":
		case "response_user_getfirstsurname":
		case "response_user_getlastsurname":										
		case "response_user_getname":
			alert("USER INFO:" + JSON.stringify(response.data));	

		//action response
		case "response_takenextbest":
		case "response_interaction_requeue":
		case "response_interaction_comment":
		case "response_interaction_get":
		case "response_interaction_archive":
		case "response_interaction_getparameter":
		case "response_interaction_getdispositioncodes":
		case "response_interaction_getmessages":
		case "response_interaction_geteventlist":
			console.log("LOG ACTION:" + messageId + " RESULT:" + JSON.stringify(response.data));
			break;
	}

}

$(document).ready(function() {

	icControl = new ICControl(ProcessResponse);

	$("form[name='formLogin']").find("#submitButton1").bind("click", function() {				
			
		icControl.TakeNextBest();				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton2").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction.value;		
		icControl.Interaction_Requeue(interaction);				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton3").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction1.value;	
		var comment = document.forms.formLogin.elements.comment.value;	
		icControl.Interaction_Comment(interaction, comment);
				
		return false;
	});				

	$("form[name='formLogin']").find("#submitButton4").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction2.value;		
		icControl.Interaction_Get(interaction);
				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton5").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction3.value;		
		var disposition = document.forms.formLogin.elements.disposition.value !== "" && document.forms.formLogin.elements.disposition.value || undefined;
		var comment = document.forms.formLogin.elements.comment1.value;
		icControl.Interaction_Archive(interaction, disposition, comment);
				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton6").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction4.value;		
		var parameter = document.forms.formLogin.elements.parameter.value;
		icControl.Interaction_GetParameter(interaction, parameter);
				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton7").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction5.value;		
		icControl.Interaction_GetDispositionCodes(interaction);
				
		return false;
	});		

	$("form[name='formLogin']").find("#submitButton8").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction6.value;		
		icControl.Interaction_GetMessages(interaction);
				
		return false;
	});	

	$("form[name='formLogin']").find("#submitButton9").bind("click", function() {				
		
		var interaction = document.forms.formLogin.elements.interaction7.value;		
		icControl.Interaction_GetEventList(interaction);
				
		return false;
	});		

	$("form[name='formLogin']").find("#submitButton10").bind("click", function() {				
			
		icControl.User_GetCompanyInformation();
				
		return false;
	});	
	$("form[name='formLogin']").find("#submitButton11").bind("click", function() {				
			
		icControl.User_GetCustomInformation();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton12").bind("click", function() {				
			
		icControl.User_GetCompleteName();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton13").bind("click", function() {				
			
		icControl.User_GetFirstName();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton14").bind("click", function() {				
			
		icControl.User_GetLastName();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton15").bind("click", function() {				
			
		icControl.User_GetFirstSurname();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton16").bind("click", function() {				
			
		icControl.User_GetLastSurname();
				
		return false;
	});
	$("form[name='formLogin']").find("#submitButton17").bind("click", function() {				
			
		icControl.User_GetName();
				
		return false;
	});						

	$("form[name='formLogin']").find("#submitButton18").bind("click", function() {				
			
		icControl.Window_Close();
				
		return false;
	});	
	
	return false;
		
});