/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.outgoingBatchesStatistics) {
	inConcert.outgoingBatchesStatistics = {};
}
if (!inConcert.outgoingBatchesStatistics.account) {
	inConcert.outgoingBatchesStatistics.account = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var definition = [];

	function Statistics (rawData)
	{
		var slices = [
			inConcert.outgoingBatchesStatisticsSlices.today,
			inConcert.outgoingBatchesStatisticsSlices.yesterday,
			inConcert.outgoingBatchesStatisticsSlices.last7days,
			inConcert.outgoingBatchesStatisticsSlices.last28days,
			inConcert.outgoingBatchesStatisticsSlices.total
		];
		Statistics.uber.constructor.call(this, definition, slices, inConcert.outgoingBatchesStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.outgoingBatchesStatistics.account.base);
	if (typeof inConcert.outgoingBatchesStatistics.account.rcs !== "function") {
		inConcert.outgoingBatchesStatistics.account.rcs = Statistics;
	}
	
	Statistics.prototype.StatisticsEnabled = function() {
		return false;
	};
	
	Statistics.prototype.GetClassName = function() {
		return "rcsBatch";
	};
	
	Statistics.prototype.GetNewBatchText = function() {
		return "<%=_T('New')%>";
	};

}());