
module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "Campaigns"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetUserCampaigns (vcc, userId, keyspace)
	return utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "UserCampaigns",
		key = utils.AppendVcc(userId, vcc)
	} or {}
end
