/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	function adm_process_flow_connection_main_popup(editor, connector, type) {
		adm_process_flow_connection_main_popup.uber.constructor.call(this, editor, connector);

		this.eventDefinition = {
			id : "event",
			name : "<%=_T('Event')%>",
			description : "<%=_T('Transition event.')%>",
			required : true,
			options : inConcert.adm_process_flow_events[type],
			sort : true,
			not_extended : true,
			form_group: true
		};
		this.type = type;
		
		this.focusControl = this.eventDefinition;
	}

	inConcert.Utils.inherit( adm_process_flow_connection_main_popup, inConcert.adm_process_flow_connection_popup );

	if (typeof inConcert.adm_process_flow_connection_main_popup !== "function") {
		inConcert.adm_process_flow_connection_main_popup = adm_process_flow_connection_main_popup;
	}

	adm_process_flow_connection_main_popup.prototype.__getClassName = function() {
		return adm_process_flow_connection_main_popup.uber.__getClassName.call(this) + " statesConnector";
	};

	adm_process_flow_connection_main_popup.prototype.__makeContent = function() { 
		var $content = adm_process_flow_connection_main_popup.uber.__makeContent.call(this);

		$content[0]
		.find(".card-block")
		.prepend(
			this.__makeDivFlex(
			[
				this.__makeDivFlex(
				[
					this.__makeComboFlex(
					this.eventDefinition,
					this.data[this.eventDefinition.id]
					),
				],
				{ class: "col-12" }
				),
			],
			{ class: "row" }
			)
		);
		// $content.unshift(this.__makeRowFlex(this.__makeComboFlex(this.eventDefinition, this.data[this.eventDefinition.id])));
		return $content;
	};

	adm_process_flow_connection_main_popup.prototype.__getAndValidate = function() {
		var data = adm_process_flow_connection_main_popup.uber.__getAndValidate.call(this);
		this.__addValue(data, this.eventDefinition);
		return data;
	};

}());
