require "luarocks.require"
local lfs = require "lfs"
require "md5"
require "json"
local http = require"socket.http"

local testUrl = [[http://localhost:8082/inconcert/apps/repository/add/?]]

for k,v in pairs{
	id="asdfg54tw4gwfgsr5ergdfbdf",
	section=1,
	part=1,
	format="mp3",
	contentType="audio"
} do
	testUrl = testUrl .. k .. "=" .. v .. "&"
end

os.execute("cls")

function GetFileSize(rowFile)
	local attribs = lfs.attributes(rowFile)
	if (attribs) then
		return attribs.size
	end
	return 0
end


local filename = "sleep.mp3"
local f = io.open(filename, "rb")
local data
if (f) then
	data = f:read("*a")
	f:close()
else
	print("cannot open file \n")
	return
end

local filesize = GetFileSize(filename)
local dataToSend = data --string.rep("hola ", 1024 * 10)

local resultChunks = {}
local r, code, headers = http.request {
	method = "POST",
	sink = ltn12.sink.table(resultChunks),
	headers = { ["Content-Length"] = filesize, ["Content-Type"] = "text/plain", },
	url = testUrl,
	source = ltn12.source.string(dataToSend)
}
print(r, code, headers)
if headers then
	for k,v in pairs(headers) do
		print(k,v)
	end
end
print(httpStatus)
local plainResponse = table.concat(resultChunks)
print(plainResponse)