
local wsapi = require "wsapi"
wsapi.inconcertWebHandler = require "wsapi.inconcertWebHandler"
wsapi.deflater = require "wsapi.deflater"

require "inconcert.loaders.debug"
require "inconcert.appMounter"

require "inconcert.appReadyFilter"
require "webHandler.path"

local Mount = inconcert.appMounter.Mount

local rules = {
	["default"] = {

		Mount{	match = "^/inconcert/apps/repository/.*$",
			name = "repository",
			displayName = "repository",
			showInDashboard = false,
			filters = {
				inconcert.appReadyFilter.makeFilter("repository"),
				wsapi.deflater.makeDeflater
			}
		}
	}
}

return rules
