/*jshint quotmark:false*/
/*global $, inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snStatistics) {
	inConcert.snStatistics = {};
}
if (!inConcert.snStatistics.account) {
	inConcert.snStatistics.account = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function Statistics (definition, slices, defaultSlice, rawData)
	{
		Statistics.uber.constructor.call(this, definition, slices, defaultSlice, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.snStatistics.base);
	if (typeof inConcert.snStatistics.account.base !== "function") {
		inConcert.snStatistics.account.base = Statistics;
	}
	
	Statistics.prototype.GetContent = function(callback) {
		callback = callback || $.noop;
		callback(null);
	};
	
	Statistics.prototype.GetAccountData = function() {
		return {
			type		: this.type,
			campaign	: this.campaign,
			account		: this.account,
			page		: this.page || ""
		};
	};
	
	Statistics.prototype.GetData = function() {
		return this.statistics || {};
	};

}());