import EventManager  from './EventManager';
class BrowserMonitor {
    #eventManager
    constructor() {
        this.#eventManager = new EventManager();
        this.#eventManager.startSender();
    }
    async markEvent (eventName, eventData){
        this.#eventManager.addEvent(eventName,eventData);
    }
    startHealthCapture(opts,data_callback){
        
        this.#eventManager.startSystemMonitor(opts);
        if(data_callback){
            this.#eventManager.addSenderCallback(data_callback)
        }
    }

    stopHealthCapture(){
        this.#eventManager.stopSystemMonitor();
    }
};
export default BrowserMonitor;
