local m_helpers = require "helpers"

LogDebug = LogDebug or function(s) print(tostring(s)) end
LogInfo = LogInfo or function(s) print(tostring(s)) end
LogWarning = LogWarning or function(s) print(tostring(s)) end

-- local postData = [[
-- 	{
-- 		"sqlSentence": "SELECT * FROM TBL",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": null
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "SELECT * FROM TBL WHERE ID = 1",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 			  "type": "ComparisonBooleanPrimary",
-- 			  "left": {
-- 				"type": "Identifier",
-- 				"value": "ID"
-- 			  },
-- 			  "operator": "=",
-- 			  "right": {
-- 				"type": "Number",
-- 				"value": "1"
-- 			  }
-- 			}
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "SELECT * FROM TBL WHERE ID = 1 OR State = 'ACTIVE'",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 				"type": "OrExpression",
-- 				"operator": "OR",
-- 				"left": {
-- 				  "type": "ComparisonBooleanPrimary",
-- 				  "left": {
-- 					"type": "Identifier",
-- 					"value": "ID"
-- 				  },
-- 				  "operator": "=",
-- 				  "right": {
-- 					"type": "Number",
-- 					"value": "1"
-- 				  }
-- 				},
-- 				"right": {
-- 				  "type": "ComparisonBooleanPrimary",
-- 				  "left": {
-- 					"type": "Identifier",
-- 					"value": "ID"
-- 				  },
-- 				  "operator": "=",
-- 				  "right": {
-- 					"type": "Number",
-- 					"value": "10"
-- 				  }
-- 				}
-- 			}
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "Select * from tbl Where Name Like 'Emma'",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 				"type": "LikePredicate",
-- 				"hasNot": null,
-- 				"left": {
-- 				  "type": "Identifier",
-- 				  "value": "Name"
-- 				},
-- 				"right": {
-- 				  "type": "String",
-- 				  "value": "'Emma'"
-- 				},
-- 				"escape": null
-- 			  }
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "Select * from tbl Where Name Like 'Emma' AND State = 'ACTIVE' AND ID = 1",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 				"type": "AndExpression",
-- 				"operator": "AND",
-- 				"left": {
-- 				  "type": "AndExpression",
-- 				  "operator": "AND",
-- 				  "left": {
-- 					"type": "LikePredicate",
-- 					"hasNot": null,
-- 					"left": {
-- 					  "type": "Identifier",
-- 					  "value": "Name"
-- 					},
-- 					"right": {
-- 					  "type": "String",
-- 					  "value": "'Emma'"
-- 					},
-- 					"escape": null
-- 				  },
-- 				  "right": {
-- 					"type": "ComparisonBooleanPrimary",
-- 					"left": {
-- 					  "type": "Identifier",
-- 					  "value": "State"
-- 					},
-- 					"operator": "=",
-- 					"right": {
-- 					  "type": "String",
-- 					  "value": "'ACTIVE'"
-- 					}
-- 				  }
-- 				},
-- 				"right": {
-- 				  "type": "ComparisonBooleanPrimary",
-- 				  "left": {
-- 					"type": "Identifier",
-- 					"value": "ID"
-- 				  },
-- 				  "operator": "=",
-- 				  "right": {
-- 					"type": "Number",
-- 					"value": "1"
-- 				  }
-- 				}
-- 			  }
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "Select * from tbl Where Name Like 'Emma' AND (State = 'ACTIVE' or State = 'FINISHED')",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 			  "type": "AndExpression",
-- 			  "operator": "AND",
-- 			  "left": {
-- 				"type": "LikePredicate",
-- 				"hasNot": null,
-- 				"left": {
-- 				  "type": "Identifier",
-- 				  "value": "Name"
-- 				},
-- 				"right": {
-- 				  "type": "String",
-- 				  "value": "'Emma'"
-- 				},
-- 				"escape": null
-- 			  },
-- 			  "right": {
-- 				"type": "SimpleExprParentheses",
-- 				"value": {
-- 				  "type": "ExpressionList",
-- 				  "value": [
-- 					{
-- 					  "type": "OrExpression",
-- 					  "operator": "or",
-- 					  "left": {
-- 						"type": "ComparisonBooleanPrimary",
-- 						"left": {
-- 						  "type": "Identifier",
-- 						  "value": "State"
-- 						},
-- 						"operator": "=",
-- 						"right": {
-- 						  "type": "String",
-- 						  "value": "'ACTIVE'"
-- 						}
-- 					  },
-- 					  "right": {
-- 						"type": "ComparisonBooleanPrimary",
-- 						"left": {
-- 						  "type": "Identifier",
-- 						  "value": "State"
-- 						},
-- 						"operator": "=",
-- 						"right": {
-- 						  "type": "String",
-- 						  "value": "'FINISHED'"
-- 						}
-- 					  }
-- 					}
-- 				  ]
-- 				}
-- 			  }
-- 			}
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "Select * from tbl Where Name Like 'Emma' AND ((State = 'ACTIVE' AND ID = 1) OR (State <> 'FINISHED' AND Id > 10))",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 			  "type": "AndExpression",
-- 			  "operator": "AND",
-- 			  "left": {
-- 				"type": "LikePredicate",
-- 				"hasNot": null,
-- 				"left": {
-- 				  "type": "Identifier",
-- 				  "value": "Name"
-- 				},
-- 				"right": {
-- 				  "type": "String",
-- 				  "value": "'Emma'"
-- 				},
-- 				"escape": null
-- 			  },
-- 			  "right": {
-- 				"type": "SimpleExprParentheses",
-- 				"value": {
-- 				  "type": "ExpressionList",
-- 				  "value": [
-- 					{
-- 					  "type": "OrExpression",
-- 					  "operator": "OR",
-- 					  "left": {
-- 						"type": "SimpleExprParentheses",
-- 						"value": {
-- 						  "type": "ExpressionList",
-- 						  "value": [
-- 							{
-- 							  "type": "AndExpression",
-- 							  "operator": "AND",
-- 							  "left": {
-- 								"type": "ComparisonBooleanPrimary",
-- 								"left": {
-- 								  "type": "Identifier",
-- 								  "value": "State"
-- 								},
-- 								"operator": "=",
-- 								"right": {
-- 								  "type": "String",
-- 								  "value": "'ACTIVE'"
-- 								}
-- 							  },
-- 							  "right": {
-- 								"type": "ComparisonBooleanPrimary",
-- 								"left": {
-- 								  "type": "Identifier",
-- 								  "value": "ID"
-- 								},
-- 								"operator": "=",
-- 								"right": {
-- 								  "type": "Number",
-- 								  "value": "1"
-- 								}
-- 							  }
-- 							}
-- 						  ]
-- 						}
-- 					  },
-- 					  "right": {
-- 						"type": "SimpleExprParentheses",
-- 						"value": {
-- 						  "type": "ExpressionList",
-- 						  "value": [
-- 							{
-- 							  "type": "AndExpression",
-- 							  "operator": "AND",
-- 							  "left": {
-- 								"type": "ComparisonBooleanPrimary",
-- 								"left": {
-- 								  "type": "Identifier",
-- 								  "value": "State"
-- 								},
-- 								"operator": "<>",
-- 								"right": {
-- 								  "type": "String",
-- 								  "value": "'FINISHED'"
-- 								}
-- 							  },
-- 							  "right": {
-- 								"type": "ComparisonBooleanPrimary",
-- 								"left": {
-- 								  "type": "Identifier",
-- 								  "value": "Id"
-- 								},
-- 								"operator": ">",
-- 								"right": {
-- 								  "type": "Number",
-- 								  "value": "10"
-- 								}
-- 							  }
-- 							}
-- 						  ]
-- 						}
-- 					  }
-- 					}
-- 				  ]
-- 				}
-- 			  }
-- 			}
-- 		  }
-- 		}
-- 	  }
-- ]]

-- local postData = [[
-- 	{
-- 		"sqlSentence": "Select * from tbl Where Name Like 'Emma' AND ((State = 'ACTIVE' AND ID = 1) OR (State <> 'FINISHED' AND Id > 10)) AND Description = 'ACTIVE'",
-- 		"sqlParsed": {
-- 		  "value": {
-- 			"where": {
-- 				"type": "AndExpression",
-- 				"operator": "AND",
-- 				"left": {
-- 				  "type": "AndExpression",
-- 				  "operator": "AND",
-- 				  "left": {
-- 					"type": "LikePredicate",
-- 					"hasNot": null,
-- 					"left": {
-- 					  "type": "Identifier",
-- 					  "value": "Name"
-- 					},
-- 					"right": {
-- 					  "type": "String",
-- 					  "value": "'Emma'"
-- 					},
-- 					"escape": null
-- 				  },
-- 				  "right": {
-- 					"type": "SimpleExprParentheses",
-- 					"value": {
-- 					  "type": "ExpressionList",
-- 					  "value": [
-- 						{
-- 						  "type": "OrExpression",
-- 						  "operator": "OR",
-- 						  "left": {
-- 							"type": "SimpleExprParentheses",
-- 							"value": {
-- 							  "type": "ExpressionList",
-- 							  "value": [
-- 								{
-- 								  "type": "AndExpression",
-- 								  "operator": "AND",
-- 								  "left": {
-- 									"type": "ComparisonBooleanPrimary",
-- 									"left": {
-- 									  "type": "Identifier",
-- 									  "value": "State"
-- 									},
-- 									"operator": "=",
-- 									"right": {
-- 									  "type": "String",
-- 									  "value": "'ACTIVE'"
-- 									}
-- 								  },
-- 								  "right": {
-- 									"type": "ComparisonBooleanPrimary",
-- 									"left": {
-- 									  "type": "Identifier",
-- 									  "value": "ID"
-- 									},
-- 									"operator": "=",
-- 									"right": {
-- 									  "type": "Number",
-- 									  "value": "1"
-- 									}
-- 								  }
-- 								}
-- 							  ]
-- 							}
-- 						  },
-- 						  "right": {
-- 							"type": "SimpleExprParentheses",
-- 							"value": {
-- 							  "type": "ExpressionList",
-- 							  "value": [
-- 								{
-- 								  "type": "AndExpression",
-- 								  "operator": "AND",
-- 								  "left": {
-- 									"type": "ComparisonBooleanPrimary",
-- 									"left": {
-- 									  "type": "Identifier",
-- 									  "value": "State"
-- 									},
-- 									"operator": "<>",
-- 									"right": {
-- 									  "type": "String",
-- 									  "value": "'FINISHED'"
-- 									}
-- 								  },
-- 								  "right": {
-- 									"type": "ComparisonBooleanPrimary",
-- 									"left": {
-- 									  "type": "Identifier",
-- 									  "value": "Id"
-- 									},
-- 									"operator": ">",
-- 									"right": {
-- 									  "type": "Number",
-- 									  "value": "10"
-- 									}
-- 								  }
-- 								}
-- 							  ]
-- 							}
-- 						  }
-- 						}
-- 					  ]
-- 					}
-- 				  }
-- 				},
-- 				"right": {
-- 				  "type": "ComparisonBooleanPrimary",
-- 				  "left": {
-- 					"type": "Identifier",
-- 					"value": "Description"
-- 				  },
-- 				  "operator": "=",
-- 				  "right": {
-- 					"type": "String",
-- 					"value": "'ACTIVE'"
-- 				  }
-- 				}
-- 			  }
-- 		  }
-- 		}
-- 	  }
-- ]]

local postData = [[
	{
		"sqlSentence": "Select * from tbl Where (Name Like 'Emma' OR Name Like 'Rocio') AND (((State = 'ACTIVE' AND ID = 1) OR (State <> 'FINISHED' AND Id > 10)) AND Description = 'ACTIVE')",
		"sqlParsed": {
		  "value": {
			"where": {
				"type": "AndExpression",
				"operator": "AND",
				"left": {
				  "type": "SimpleExprParentheses",
				  "value": {
					"type": "ExpressionList",
					"value": [
					  {
						"type": "OrExpression",
						"operator": "OR",
						"left": {
						  "type": "LikePredicate",
						  "hasNot": null,
						  "left": {
							"type": "Identifier",
							"value": "Name"
						  },
						  "right": {
							"type": "String",
							"value": "'Emma'"
						  },
						  "escape": null
						},
						"right": {
						  "type": "LikePredicate",
						  "hasNot": null,
						  "left": {
							"type": "Identifier",
							"value": "Name"
						  },
						  "right": {
							"type": "String",
							"value": "'Rocio'"
						  },
						  "escape": null
						}
					  }
					]
				  }
				},
				"right": {
				  "type": "SimpleExprParentheses",
				  "value": {
					"type": "ExpressionList",
					"value": [
					  {
						"type": "AndExpression",
						"operator": "AND",
						"left": {
						  "type": "SimpleExprParentheses",
						  "value": {
							"type": "ExpressionList",
							"value": [
							  {
								"type": "OrExpression",
								"operator": "OR",
								"left": {
								  "type": "SimpleExprParentheses",
								  "value": {
									"type": "ExpressionList",
									"value": [
									  {
										"type": "AndExpression",
										"operator": "AND",
										"left": {
										  "type": "ComparisonBooleanPrimary",
										  "left": {
											"type": "Identifier",
											"value": "State"
										  },
										  "operator": "=",
										  "right": {
											"type": "String",
											"value": "'ACTIVE'"
										  }
										},
										"right": {
										  "type": "ComparisonBooleanPrimary",
										  "left": {
											"type": "Identifier",
											"value": "ID"
										  },
										  "operator": "=",
										  "right": {
											"type": "Number",
											"value": "1"
										  }
										}
									  }
									]
								  }
								},
								"right": {
								  "type": "SimpleExprParentheses",
								  "value": {
									"type": "ExpressionList",
									"value": [
									  {
										"type": "AndExpression",
										"operator": "AND",
										"left": {
										  "type": "ComparisonBooleanPrimary",
										  "left": {
											"type": "Identifier",
											"value": "State"
										  },
										  "operator": "<>",
										  "right": {
											"type": "String",
											"value": "'FINISHED'"
										  }
										},
										"right": {
										  "type": "ComparisonBooleanPrimary",
										  "left": {
											"type": "Identifier",
											"value": "Id"
										  },
										  "operator": ">",
										  "right": {
											"type": "Number",
											"value": "10"
										  }
										}
									  }
									]
								  }
								}
							  }
							]
						  }
						},
						"right": {
						  "type": "ComparisonBooleanPrimary",
						  "left": {
							"type": "Identifier",
							"value": "Description"
						  },
						  "operator": "=",
						  "right": {
							"type": "String",
							"value": "'ACTIVE'"
						  }
						}
					  }
					]
				  }
				}
			  }
		  }
		}
	  }
]]


-----------------------------------------------------------------------------
-- Queries
------------------------------------------------------------------------------
local m_queries = {}

m_queries.MakeOperatorConfig = function (self, line)
	if not line then
		LogDebug("1 - MakeOperatorConfig" )
		return
	end
	-- assert(type(line.operator) == "string")
	-- assert(type(line.logicalOp) == "string")
	-- maps
	-- local mapLogicalOperators = {
	-- 	["AND"] = "and", -- must
	-- 	["OR"]  = "or"
	-- }
	local mapConditionOperators = {
		["="] = {
			operator = "equal", --"term",
		--	mapLogicalOp = mapLogicalOperators
		},
		["<>"] = {
			operator = "distinct", -- "term",
			mapLogicalOp = mapLogicalOperators --"must_not"
		},
		[">"] = {
			operator = "greater", -- "range"
		--	mapLogicalOp = mapLogicalOperators
			--operator = "gt"
		},
		[">="] = {
			operator = "greater_equal", --"range",
			mapLogicalOp = mapLogicalOperators
			--operator = "gte"
		},
		["<"] = {
			operator = "less", -- "range",
		--	mapLogicalOp = mapLogicalOperators
			--operator = "lt"
		},
		["<="] = {
			operator = "less_equal", --"range",
		--	mapLogicalOp = mapLogicalOperators
			--operator = "lte"
		},
		["LIKE"] = {
			operator = "contains", -- "match", wildcard
			mapLogicalOp = mapLogicalOperators
		}
	}

	local operator = line.operator:upper()
	--local logicalOp = line.logicalOp:upper()
	local info = mapConditionOperators[operator]
	assert(info)
	local operatorConfig = {
		operator = info.operator,
		--logicalOp   = nil--,
		--operator    = info.operator
	}
	-- if type(info.mapLogicalOp) == "string" then
	-- 	operatorConfig.logicalOp = info.mapLogicalOp
	-- else
	-- 	operatorConfig.logicalOp = info.mapLogicalOp[logicalOp] or mapLogicalOperators.AND
	-- end
	LogDebug("2 - MakeOperatorConfig operatorConfig " .. json.encode(operatorConfig))
	return operatorConfig
end

m_queries.MakeQueryESConditions = function (self, rawData)
	LogDebug("[OUTBOUNDENGINE.CLIENT:m_queries.MakeQueryESConditions] --> START Making ES Conditions. rawData: %s", m_helpers.table:JSON_Encode(rawData))
	local conditions = {
		type = nil,
		conditions = {}
	}

	local function RecursiveFill (sqlWhereCondition, elascticSearchConditions)
		if not sqlWhereCondition or not next(sqlWhereCondition) then
			return
		end
		local conditionType = (sqlWhereCondition.type):upper()
		if conditionType == "COMPARISONBOOLEANPRIMARY" or conditionType == "LIKEPREDICATE" then
			assert(type(sqlWhereCondition.left) == "table")
			assert(type(sqlWhereCondition.right) == "table")
			--
			local fieldName = sqlWhereCondition.left.value
			local fieldValue = sqlWhereCondition.right.value
			local fieldType = (sqlWhereCondition.right.type or ""):upper()
			if fieldType == "NUMBER" then
				fieldValue = tonumber(fieldValue)
			elseif fieldType == "STRING" then
				-- contra helpers
				fieldValue = fieldValue:gsub("'", "")
			end
			if conditionType == "LIKEPREDICATE" then
				sqlWhereCondition.operator = sqlWhereCondition.operator or "LIKE"
			end
			local operatorConfig = self:MakeOperatorConfig(sqlWhereCondition)
			local condition = {
				type  = operatorConfig.operator,
				name  = fieldName, --"State",
				value = fieldValue, -- "ACTIVE"
			}
			table.insert(elascticSearchConditions, condition)

		elseif conditionType == "ANDEXPRESSION" or conditionType == "OREXPRESSION" then
			assert(type(sqlWhereCondition.left) == "table")
			assert(type(sqlWhereCondition.right) == "table")
			local condition = {
				type       = conditionType == "ANDEXPRESSION" and "and" or "or",
				conditions = {}
			}
			RecursiveFill(sqlWhereCondition.left, condition.conditions)
			RecursiveFill(sqlWhereCondition.right, condition.conditions)
			table.insert(elascticSearchConditions, condition)

		elseif conditionType == "SIMPLEEXPRPARENTHESES" then
			assert(type(sqlWhereCondition.value) == "table")
			RecursiveFill(sqlWhereCondition.value, elascticSearchConditions)

		elseif conditionType == "EXPRESSIONLIST" then
			assert(type(sqlWhereCondition.value) == "table")
			local expressionList = sqlWhereCondition.value
			for _, expression in ipairs(expressionList) do
				RecursiveFill(expression, elascticSearchConditions)
			end
		else
			assert(false, "Unrecognized SQL Parser Condition Type: " .. conditionType)
		end
	end

	local sqlParsed = rawData.sqlParsed
	RecursiveFill(sqlParsed.value.where, conditions.conditions)

	LogDebug("[OUTBOUNDENGINE.CLIENT:m_queries.MakeQueryESConditions] --> END Maked ES Conditions. conditions: %s", m_helpers.table:JSON_Encode(conditions))
	return true, conditions
end

local rawData = m_helpers.table:JSON_Decode(postData)
local succes, conditions = m_queries:MakeQueryESConditions(rawData)


