module(..., package.seeall)

local m_datasource

function GetName ()
	return "Request"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetRequest (requestId)
	local key = "ApiRequest:" .. requestId
	local request = m_datasource.redis:get(key)
	request = type(request) == "string" and request ~= "" and json.decode(request) or nil
	if request then
		m_datasource.redis:del(key)
	end
	return request
end
