local m_definitions = {
	basic = {
		isSimple = true,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Name",
				validations = {
					id_without_dots_underscore = "Only letters and numbers are allowed in database name.",
					html_malicious_code = "Possible malicious code in the database Name."
				}
			},
			{
				field_id = "Description",
				validations = {
					html_malicious_code = "Possible malicious code in the database Description."
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}
