local m_definitions = {
	basic = {
		isSimple = false,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Id",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the workgroup Id.",
					html_malicious_code = "Possible malicious code in the workgroup Id."
				}
			},
			{
				field_id = "Name",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the workgroup Name.",
					html_malicious_code = "Possible malicious code in the workgroup Name."
				}
			},
			{
				field_id = "Description",
				validations = {
					html_malicious_code = "Possible malicious code in the workgroup Description."
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}

