/*jslint evil:true nomen:false regexp: false*/
/*global $, jQuery, window, inConcert, air

*/


// Create an inConcert object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	/**
	Class TwitterSearchWindow.
	*/
	function TwitterSearchWindow ()
	{
		TwitterSearchWindow.uber.constructor.call(this, 
								{ move : ["topDragBar", "bottomDragBar"],
									resizer : "resizeGripper"
								});
	}

	inConcert.Utils.inherit(TwitterSearchWindow, inConcert.Window);

	$(document).ready(function() {
		inConcert.i18n.updateScreen();
		window.onReady(inConcert, window);
		var searches = new TwitterSearchWindow();
	});
}());

