/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.batchManagementCreate) {
	inConcert.batchManagementCreate = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function CreatePopup (account)
	{
		CreatePopup.uber.constructor.call(this, account);
	}
	
	inConcert.Utils.inherit(CreatePopup, inConcert.batchManagementCreate.base);
	if (typeof inConcert.batchManagementCreate.rcs !== "function") {
		inConcert.batchManagementCreate.rcs = CreatePopup;
	}
	
	CreatePopup.prototype.__getTitle = function() {
		return "<%=_T('Create Rcs messages batch on')%>";
	};
	
	CreatePopup.prototype.__getTextLimit = function() {
		return 160;
	};
	
	CreatePopup.prototype.__getClassName = function() {
		return "rcsBatch";
	};
	
	CreatePopup.prototype.__validatePhoneNumber = function(number) {
		// allow the agent to call a cab, but not Uruguay's Speaking clock
		return number.length > 2 && number.match(/^[\- \(\)\+0-9_.*#]+$/);
	};
	
	CreatePopup.prototype.__getAndValidateAddress = function(address_t) {
		return this.__validatePhoneNumber(address_t) && address_t.replace(/[^0-9#*\+]/g, "") || false;
	};

}());