/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function ActiveList ()
	{
		ActiveList.uber.constructor.call(this);
		this.batch_actions = [
			"PAUSE",
			"RESUME",
			"SET_ATTRIBUTES",
			"CLOSE"
		];
	}

	inConcert.Utils.inherit(ActiveList, inConcert.batchManagementList.base);
	if (typeof inConcert.batchManagementList.active !== "function") {
		inConcert.batchManagementList.active = ActiveList;
	}
	
	ActiveList.prototype.__getPermission = function() {
		return "active_batches";
	};

	ActiveList.prototype.GetView = function() {
		return "ACTIVE";
	};

	ActiveList.prototype.RetrieveType = function() {
		return "ACTIVE";
	};

	ActiveList.prototype.GetName = function() {
		return "<%=_T('Active')%>";
	};

	ActiveList.prototype.GetDescription = function() {
		return "<%=_T('Active batches')%>";
	};

	ActiveList.prototype.GetClassName = function() {
		return "categoryActive";
	};
}());