/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function TotalList ()
	{
		TotalList.uber.constructor.call(this);
		this.batch_actions = [
			"REOPEN",
			"PAUSE",
			"RESUME",
			"SET_ATTRIBUTES",
			"CLOSE"
		];
	}

	inConcert.Utils.inherit(TotalList, inConcert.batchManagementList.base);
	if (typeof inConcert.batchManagementList.total !== "function") {
		inConcert.batchManagementList.total = TotalList;
	}

	TotalList.prototype.HasPermission = function(campaign) {
		return  inConcert.app.getBatchesManager().
		HasPermission(campaign, "batches_history") || inConcert.app.getBatchesManager().
		HasPermission(campaign, "active_batches");
	};

	TotalList.prototype.__getPermission = function() {
		return "active_batches";
	};

	TotalList.prototype.GetView = function() {
		return "TOTAL";
	};

	TotalList.prototype.RetrieveType = function() {
		let retrieveType = inConcert.batch_management.getSelectedTabId();
		return retrieveType;
	};

	TotalList.prototype.GetName = function() {
		return "<%=_T('Total batches')%>";
	};

	TotalList.prototype.GetDescription = function() {
		return "<%=_T('Total batches (include deleted)')%>";
	};

	TotalList.prototype.GetClassName = function() {
		return "categoryTotal";
	};
}());