/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

	var actions = [
		{
			id : "new_state",
			name : "<%=_T('New State')%>",
			description : "<%=_T('New State')%>"
		},
		{
			id : "properties",
			name : "<%=_T('Properties')%>",
			description : "<%=_T('Properties')%>",
			selection : true,
			singleSelection : true
		},
		{
			id : "duplicate",
			name : "<%=_T('Duplicate')%>",
			description : "<%=_T('Duplicate')%>",
			selection : true,
			singleSelection : true
		},
		{
			id : "delete",
			name : "<%=_T('Delete')%>",
			description : "<%=_T('Delete (delete).')%>",
			selection : true,
			connectors : true,
			confirmation : {
				nodes: "<%=_T('Do you want to delete states?')%>",
				connectors: null
			}
		},
		{
			id : "zoom_in",
			name : "<%=_T('Zoom In')%>",
			description : "<%=_T('Zoom in.')%>",
			withoutText : true,
			sectionBegin : "flowDesignerZoomActions"
		},
		{
			id : "zoom_out",
			name : "<%=_T('Zoom Out')%>",
			description : "<%=_T('Zoom out.')%>",
			withoutText : true
		},
		{
			id : "zoom_actual",
			name : "<%=_T('Restore Zoom')%>",
			description : "<%=_T('Restore size.')%>",
			withoutText : true
		}
	];

	function adm_process_flow_main_actions_bar(main) {
		adm_process_flow_main_actions_bar.uber.constructor.call(this, main);
	}

	inConcert.Utils.inherit( adm_process_flow_main_actions_bar, inConcert.adm_process_flow_actions_bar );

	if (typeof inConcert.adm_process_flow_main_actions_bar !== "function") {
		inConcert.adm_process_flow_main_actions_bar = adm_process_flow_main_actions_bar;
	}

	adm_process_flow_main_actions_bar.prototype.GetActions = function() {
		return actions;
	};

}());
