/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
//message types
	
	function adm_process_flow_messages_type_text(parent) {
		adm_process_flow_messages_type_text.uber.constructor.call(this, parent);
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_text, inConcert.adm_process_flow_messages_type.base.text );
	
	adm_process_flow_messages_type_text.prototype.__hasButtons = function() {
		return false;
	};
	
	if (!inConcert.adm_process_flow_messages_type.rcs) {
		inConcert.adm_process_flow_messages_type.rcs = {
			text : adm_process_flow_messages_type_text
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.rcs_sorted) {
		inConcert.adm_process_flow_messages_type.rcs_sorted = [
			"text"
		];
	}
	
//button types
	
	if (!inConcert.adm_process_flow_messages_button.rcs) {
		inConcert.adm_process_flow_messages_button.rcs = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}
	
//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.rcs) {
		inConcert.adm_process_flow_messages_quickreply.rcs = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.rcs !== "function") {
		inConcert.adm_process_flow_messages.rcs = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 0;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
