/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";
	
//message types
	
	function adm_process_flow_messages_type_text(parent) {
		adm_process_flow_messages_type_text.uber.constructor.call(this, parent);
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_text, inConcert.adm_process_flow_messages_type.base.text );
	
	adm_process_flow_messages_type_text.prototype.__hasButtons = function() {
		return false;
	};
	
	function adm_process_flow_messages_type_attachment(parent) {
		adm_process_flow_messages_type_attachment.uber.constructor.call(this, parent);
		
		this.attachmentTypeDefinition.options = this.attachmentTypeDefinition.options.filter(function(option) {
			return option.id !== "url";
		});
		
		this.fileTypeDefinition.options = this.fileTypeDefinition.options.filter(function(option) {
			return option.id === "image";
		});
	}

	inConcert.Utils.inherit( adm_process_flow_messages_type_attachment, inConcert.adm_process_flow_messages_type.base.attachment );
	
	if (!inConcert.adm_process_flow_messages_type.twitter_bot) {
		inConcert.adm_process_flow_messages_type.twitter_bot = {
			//text : adm_process_flow_messages_type_text,
            text : inConcert.adm_process_flow_messages_type.base.text,
			attachment : adm_process_flow_messages_type_attachment
		};
	}
	
	if (!inConcert.adm_process_flow_messages_type.twitter_bot_sorted) {
		inConcert.adm_process_flow_messages_type.twitter_bot_sorted = [
			"text",
			"attachment"
		];
	}
	
//button types
	
	if (!inConcert.adm_process_flow_messages_button.twitter_bot) {
		inConcert.adm_process_flow_messages_button.twitter_bot = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}
	
//quick replies
	
	if (!inConcert.adm_process_flow_messages_quickreply.twitter_bot) {
		inConcert.adm_process_flow_messages_quickreply.twitter_bot = inConcert.adm_process_flow_messages_quickreply.base;
	}
	
//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.twitter_bot !== "function") {
		inConcert.adm_process_flow_messages.twitter_bot = adm_process_flow_messages;
	}

	adm_process_flow_messages.prototype.__maxQuickreplies = function() {
		return 0;
	};

	adm_process_flow_messages.prototype.__hasWriting = function() {
		return false;
	};

}());
