this.inConcert = this.inConcert || {};
this.inConcert.app_monitoring = this.inConcert.app_monitoring || {};

(function (app) {
    "use strict";
    function MonitoringDashboard({ container_id }) {
        this.container_id = container_id;
    }
    MonitoringDashboard.prototype.render = function ( callback = $.noop) {
        this.dashboard = document.createElement("icc-agent-monitoring-dashboard")
        this.dashboard.setAttribute("data-icc-dev-component",true);
        this.$container = $("#" + this.container_id);
        //wait for component ready 
        let wt = setInterval(()=>{
            if(typeof this.dashboard.setOptions === "function"){
                try{
                    this.dashboard.setOptions({L:<%=_L%>})
                    clearInterval(wt);
                }catch(err){
                }

            }
        },20);
        this.$container[0].appendChild(this.dashboard);
        this.$container.show();
        callback();
    };
    MonitoringDashboard.prototype.on_leave = function (finish_cb) {
        if (!this.$container) {
            return;
        }
        //Avisar que se va para desenganchar cosas
        this.dashboard.leave();
        this.$container.hide();
        this.$container[0].removeChild(this.dashboard)
        setTimeout(()=>{
            finish_cb();

        },200)
    };
    app.dashboard = MonitoringDashboard;
})(this.inConcert.app_monitoring);
