/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsCreate) {
	inConcert.snPostsCreate = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function CreatePopup (account)
	{
		CreatePopup.uber.constructor.call(this, account);
	}
	
	inConcert.Utils.inherit(CreatePopup, inConcert.snPostsCreate.base);
	if (typeof inConcert.snPostsCreate.twitter !== "function") {
		inConcert.snPostsCreate.twitter = CreatePopup;
	}
	
	CreatePopup.prototype.__getTitle = function() {
		return "<%=_T('New Tweet on')%>";
	};
	
	CreatePopup.prototype.__getTextLimit = function() {
		return 280;
	};
	
	CreatePopup.prototype.__getAvailableContentTypes = function() {
		return {
			link : true,
			image : {
				link : true,
				disk : true
			}
		};
	};
	
	CreatePopup.prototype.__getMaxFileSizeMB = function() {
		return 5;
	};
	
	CreatePopup.prototype.__addLinkToData = function(data, link, isImage) {
		data.attachment_url = link;
		if (isImage) {
			data.image = true;
		}
	};
	
	CreatePopup.prototype.__getClassName = function() {
		return "twPost";
	};
	
	CreatePopup.prototype.__addText = function(data) {
		var text = this.__getText();
		data.message = text;
	};
	
	CreatePopup.prototype.__getTextLength = function() {
		let text = this.__getText() || "";
		let textInfo = inConcert.Utils.twitterProcessMessage(text);
		this.__setTextDisclaimer(textInfo.hasUrls ? "<%=_T('Links will be shortened automatically')%>" : "");
		return textInfo.totalChars;
	};

}());