/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snStatistics) {
	inConcert.snStatistics = {};
}
if (!inConcert.snStatistics.account) {
	inConcert.snStatistics.account = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var definition = [
		{
			id : "followers",
			name : "<%=_T('Followers')%>",
			description : "<%=_T('Number of followers.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [
			inConcert.snStatisticsSlices.today,
			inConcert.snStatisticsSlices.yesterday,
			inConcert.snStatisticsSlices.last7days,
			inConcert.snStatisticsSlices.last28days,
			inConcert.snStatisticsSlices.total
		];
		Statistics.uber.constructor.call(this, definition, slices, inConcert.snStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.snStatistics.account.base);
	if (typeof inConcert.snStatistics.account.twitter !== "function") {
		inConcert.snStatistics.account.twitter = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "twPost";
	};
	
	Statistics.prototype.GetNewPostText = function() {
		return "<%=_T('New')%>";
	};

}());