// contentscript.js

const ICCBAMLIBOVERLAY_CLASS = "iccbamliboverlay";
const ICCBAMLIBEVENT_REQUEST = 'iccbamlibmessage-request';
const ICCBAMLIBEVENT_RESPONSE = 'iccbamlibmessage-response';
const ICCBAMLIBEVENT_RESPONSE_TIMOUT = 5000;

function createBamlibOverlay() {
  let div = document.createElement("div");
  div.className = ICCBAMLIBOVERLAY_CLASS;
  div.addEventListener(ICCBAMLIBEVENT_REQUEST, (e) => {
    chrome.runtime.sendMessage(
      { data: e.detail },
      (response) => {
        div.dispatchEvent(new CustomEvent(ICCBAMLIBEVENT_RESPONSE, { detail: response }))
      });
  })
  document.body.appendChild(div);
}



function bamlibOverlayExist() {
  let bamlibOverlay = document.getElementsByClassName(ICCBAMLIBOVERLAY_CLASS)[0];
  return bamlibOverlay !== null && bamlibOverlay !== undefined;
}
if (!bamlibOverlayExist()) {
  createBamlibOverlay();
}
chrome.runtime.onMessage.addListener((request) => {
  window.postMessage({ bmlibTimers: true }, "*");
  return Promise.resolve({});
});
